
/*	"REMI" - Removables Eject and Mount Intelligence  */

/* History
 *  0.10	1997/01/05	CWFNgł悤ɂȂ
 *  0.11	1997/01/09	I[v/N[Ył悤ɂȂ
 *  1		1997/04/10	VXegCɏ풓, ݒ_CAO, IEJECT, WAVE炷
 *  2		1997/05/01	zbgL[Eject/Open/Close, j[ύX\, }`[UΉ bJ
 *  2+1	1997/05/02	[U擾łȂꍇ̏ǉ
 *  2+2	1997/05/03	zbgL[̓o^ɕs̂𒼂
 *  2+3	1997/05/05	XbhoO,CTRL+ALT+DELŏIłȂoO𒼂
 *  2+4	1997/05/07	PDhCũ`FbNǉ
 *  1.0		1997/05/14	኱̏ȃ ׂBugFix J
 *  1.00.1	1997/05/17	֘A̕s𒼂
 *  1.01	1997/05/26	ufoCXĒvǉ
 *  1.01.1	1997/05/31	PDCD-ROMgp̕sC
 *  1.02	1997/06/01	Popup̉P IEjectݒ_CAȎOɃfoCXĒ pꃊ\[X
 *  1.03	1997/06/14	Ԃ̏C(^^; ׂFix \[Xt@C𓯍
 *  1.03.1	1997/07/04	OKƷݾقIDύX
 *  1.04	1997/08/15	10bCloseǉ LUNΉ V^CvPDɑΉ TOWNSEXTL[gps foCXĒɂ
 *  1.05	1998/01/23	IClose̎ԑ҂̕@ύX
 *  1.06	1998/02/02	PC-98x1Win95DOSESCȂȂssC
 *  1.07	1998/02/08	scaner\Ă܂sC
 *  1.08	1998/02/10	foCX̑}ԂołȂfoCX(LS-120,etc.)ւ̑Ή
 *  1.09	1998/02/22	LUN0LUN1Ƃ"OpticalDevice"ԂochCuւ̑Ή
 *  1.10	1998/03/07	ݒ_CAÕfUCύX CLOSEύX\
 *  1.11	1998/03/11	TuXbhǗ֐ǉ Hotkey܂̕sC O\[XΉ
 *  1.11.1	1998/03/13	GoOĂ̂C
 *  1.11.2	1998/03/17	fBA`FbNȂꍇEJECTłȂ̂C
 *  1.12	1998/03/18	CLOSE񂪕ύXłȂ̂C ̑낢C
 *  1.13	1998/04/29	j[ɂPOPUPɕ\Ȃ悤ɂ
 *  1.13.1	1998/06/20	PDCD쎞OPENłȂꍇւ̑΍
 *  1.14	1998/06/23	^XNgCACR\Ȃ@ǉ
 */

/* ς
 *  -- 1
 *  ^XNgCɃACR\ => InsideWindows 1996.9
 *  ݒ(foCXݒ)̃_CAOt
 *  dN悤Ƃꍇɂ͐ݒ_CAOJ
 *  eject/open/closewave炷
 *  foCXL^
 *  WindowsIEJECT
 *  -- 2
 *  V[gJbgL[Eject/Open/Close
 *  }`[UɑΉ
 *  -- 1.01
 *  ufoCXĒvt
 *  -- 1.04
 *  IEject, 莞ԌohAi܂sHj
 *  AhCuւ̑Ήibj
 *  -- 1.05
 *  ȏICLOSE
 *  foCX̑}ԂołȂfoCX(LS-120,etc.)ւ̑Ή
 *  LUN0LUN1Ƃ"OpticalDevice"ԂochCuւ̑Ή
 */

/* TO DO
 *  foCX̎ނɉčĐWAVEς
 *  WXgQƂăhCu\ & DeviceIOCtrlƕp
 *  foCXIDύXɂȂꍇɐݒ󂯌p(ۂ?)
 */

/* Bugs
 *  Xbh1iWNASPI32.DLL̈܂H Ɏx͖݂炢...j
 */

#include <windows.h>
#include <commctrl.h>	// for Hotkey Control
#include <dbt.h>		// for WM_DEVICECHANGE
#include "aspi32.h"
#include "resource.h"

// Definition

#define IDM_EXIT                        2000
#define IDM_SETUP                       2001

#ifdef ExitEjectTest
#define IDM_TEST						2222
#endif //ExitEjectTest

#define WMMY_NOTIFYICON	(WM_APP+100)	// Message from Taskbar Icon
#define NAME_LEN	128		// Device Menu Name Maximun Length

// HOTKEYF_?  MOD_? ɕϊ (?=ALT/CONTROL/SHIFT)
// HOTKEYF_EXT͑ΏۊOɂ(v1.04)
#define HKF2MOD(w) HIBYTE((w&0x200)|((w&0x100)<<2)|((w&0x400)>>2))
/*
	COMMCTRL.H
		#define HOTKEYF_SHIFT           0x01
		#define HOTKEYF_CONTROL         0x02
		#define HOTKEYF_ALT             0x04
	WINUSER.H
		#define MOD_ALT         0x0001
		#define MOD_CONTROL     0x0002
		#define MOD_SHIFT       0x0004
*/

// Structure Definition
typedef struct{
	int		nHA;
	int		nID;
	int		nLUN;
	WORD	wSetting;
	WORD	wStatus;
	WORD	wHotkeyOpenEject;
	WORD	wHotkeyClose;
	TCHAR	szName[NAME_LEN];
	TCHAR	szNameClose[NAME_LEN];
} DeviceInfo;		// foCX̏i[邽߂̍\
/* DeviceInfo\̂̏ڍ
	int nID			̃foCXIDԍ
	int nHA			̃foCX̃zXgA_v^ԍ
	int nLUN		̃foCX̘_jbgԍ
	WORD wSetting	̃foCX̊eݒ
			bit0		1Ȃ΃g[^CvƂĐs
			bit1		1Ȃ΃foCX𖳎
			bit2		1ȂWindowsIɃfBAro(Eject)
			bit3		1Ȃ΃TEh𓯊čĐ
			bit4		1ȂWindowsIɃg[J(Open)A10bɕ(Close)
			bit5		1Ȃ΃fBȂ}Ԃ`FbNȂ
			bit6-14		reserved (should be zero)
			bit15		IEject̎OPENꂽȂ1
	WORD wHotkey...	zbgL[̐ݒ
			LOBYTE		zL[R[h
			HIBYTE		HOTKEYF_?
	TCHAR szName[]	POPUPj[\
	TCHAR szNameClose 
*/

// wSettingQƁE삷邽߂ɎgtO`
#define INFOF_TRAY			0x0001
#define INFOF_DISABLE		0x0002
#define INFOF_ENDEJECT		0x0004
#define INFOF_SOUNDSYNC		0x0008
#define INFOF_ENDCLOSE		0x0010
#define INFOF_NOCHECK		0x0020
#define INFOF_ENDOPENED		0x8000

typedef struct{
	DeviceInfo*	RemovablesInfo;
	DeviceInfo*	RemovablesInfoBuffer;
	int			iHostAdapters;
	int			iRemDevs;
} DeviceStruct;		// foCX܂Ƃ߂ēn߂̍\


// Proto type definition
LRESULT CALLBACK WndProc( HWND, UINT, WPARAM, LPARAM );
BOOL CALLBACK SetupDialogProc( HWND, UINT, WPARAM, LPARAM );
void UpdateDialogItems( HWND hDlgWnd, DeviceInfo *DevInfo, int i );
void DispCloseTime( HWND, int );
BOOL CALLBACK CommonDialogProc( HWND, UINT, WPARAM, LPARAM );
BOOL CALLBACK WaveSelectDialogProc( HWND, UINT, WPARAM, LPARAM );
BOOL GetIniName( LPSTR );
BOOL GetStdIniName( LPSTR );
void GetOtherSetting( LPSTR );
void WriteOtherSetting( LPSTR );
void GetDeviceSetting( LPSTR, LPSTR, DeviceInfo* );
void WriteDeviceSetting( LPSTR, LPSTR, DeviceInfo* );
BOOL MakePopupMenu( HMENU*, HMENU*, DeviceStruct*, HWND );
void DestroyPopupMenu( HMENU, HMENU, DeviceStruct*, HWND );
BOOL SetHotkey(HWND hWnd, int nID, WORD wHotkey );
DeviceInfo* ScanAllDevices( DeviceStruct* );
BOOL IsPD( int, int );
BOOL EjectUnit( DeviceInfo*, int );
DWORD WaitClose( DeviceStruct* );
void MakeDeviceDescription( int, int, int, unsigned char*, LPSTR );

// constant strings
const char szClassName[] = "IENAKIKO";
const char szAppName[] = "REMI";
const char szVerNum[] = "1.1";		// \[Xo[Wrp
const char szVersion[] = "Removables\nEject and Mount\nIntelligence  ver. 1.14";
const char szVersionMB[] = "Removables  Eject  and  Mount  Intelligence   ver. 1.14\n\nCompiled at " __TIME__ ", " __DATE__ "\n\nCopyright(C) 1997-98 Yuu Igarashi  ( igarakey@alles.or.jp )";

// Global Values
HANDLE g_hInst;			// CX^Xnh
HANDLE g_hResInst;		// [JCY\[XW[ECX^Xnh
LPTSTR g_lpszEjectWave, g_lpszOpenWave, g_lpszCloseWave;
UINT g_uEndCloseTime = 30;	// ICLOSE܂ł̑҂ԁiftHg3.0bj

// function implement

int PASCAL WinMain(HANDLE hInstance, HANDLE hPreInstance, LPSTR lpszCmdParam, int nCmdShow)
{
	HWND	hWnd;
	MSG		msg;

	g_hInst = hInstance;

	// łɋNĂvZXꍇɂ͐ݒʂJ
	if ( hWnd = FindWindow(szClassName,szAppName) ) {
		SetForegroundWindow( hWnd );
		PostMessage( hWnd, WM_COMMAND, IDM_SETUP, 0 );
		return FALSE;
	}

	// [JCY\[X̓ǂݍ
	g_hResInst = LoadLibraryEx("REMILOCA.DLL", NULL, DONT_RESOLVE_DLL_REFERENCES);
	if (g_hResInst) {
		char buf[16];
		LoadString(g_hResInst, IDS_VERSION, buf, sizeof(buf));
		if (lstrcmp(buf, szVerNum)) {	// o[WႤI
			FreeLibrary(g_hResInst);
			g_hResInst = g_hInst;
		}
	} else g_hResInst = g_hInst;	// \[XDLLǂݍ߂Ȃ

	// EBhENXo^
	WNDCLASS wc;
	ZeroMemory( &wc, sizeof(wc) );
	wc.lpfnWndProc	 = WndProc;
	wc.hInstance	 = g_hInst;
	wc.lpszClassName = szClassName;
	if ( !RegisterClass(&wc) ) return FALSE;

	// CEBhE쐬
	hWnd = CreateWindow(
		szClassName,	// EBhENX
		szAppName,		// EBhE
		WS_POPUP,	// EBhEX^C
		(nCmdShow!=SW_SHOWMINNOACTIVE), 0, 0, 0,		// EBhËʒuƑ傫
		NULL, NULL, g_hInst, NULL );
	if (!hWnd) return FALSE;
/*	nCmdShow ̒l
#define SW_SHOWNORMAL       1	// ʏ̃EBhE
#define SW_SHOWMAXIMIZED    3	// ő剻
#define SW_SHOWMINNOACTIVE  7	// ŏ
*/

	// bZ[W[v
	while( GetMessage(&msg,NULL,0,0) ) {
		TranslateMessage( &msg );
		DispatchMessage( &msg );
	}

	// gpĂ烊\[XDLLJ
	if (g_hInst != g_hResInst) FreeLibrary(g_hResInst);

	return ( msg.wParam );
}

///////////////////////////////////////////
// R[obN֐

LRESULT CALLBACK WndProc( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
static BOOL bShowTrayIcon;
static NOTIFYICONDATA nIcon;		// ^XNgCACRׂ̈̍\
static HMENU hMenuR=NULL, hMenuL=NULL;		// PopUpMenũnh
static DeviceStruct	DevStruct;
static DeviceInfo* DevInfo;
int	i;
HANDLE hTemp;
POINT point;
HMENU hMenu;
BOOL bEndClose;
char szTempBuf[MAX_PATH];

	switch(uMsg) {

	case WM_CREATE:
		// WinASPI32 gpł邩
		DevStruct.iHostAdapters = CheckInstallAspi32();
		if ( DevStruct.iHostAdapters == 0 ) {
			LoadString( g_hResInst, IDS_NOTASPI32, szTempBuf, sizeof(szTempBuf) );
			MessageBox( NULL, szTempBuf, szAppName, MB_ICONEXCLAMATION );
			return -1;
		}

		// Soundݒ̂߂̃m
		g_lpszEjectWave = (LPTSTR)GlobalAlloc( GPTR, MAX_PATH );
		g_lpszOpenWave  = (LPTSTR)GlobalAlloc( GPTR, MAX_PATH );
		g_lpszCloseWave = (LPTSTR)GlobalAlloc( GPTR, MAX_PATH );

		// Soundݒǂݏo
		GetIniName(szTempBuf);
		//INI݂Ȃꍇ"REMI.ini"𓾂
		if ( (hTemp = CreateFile(szTempBuf,0,0,NULL,OPEN_EXISTING,0,NULL)) == INVALID_HANDLE_VALUE )
			GetStdIniName( szTempBuf );
		else CloseHandle( hTemp );
		GetOtherSetting(szTempBuf);

		// [oufoCX̏擾
		// & foCXi[zm
		DevInfo = ScanAllDevices( &DevStruct );
		if ( !DevInfo ) return -1;	// mۂłȂ
		if ( DevStruct.iRemDevs == 0 ) {	// [oufoCX
			LoadString( g_hResInst, IDS_NOREMOVABLES, szTempBuf, sizeof(szTempBuf) );
			MessageBox( NULL, szTempBuf, szAppName, MB_OK );
			return -1;
		}

		// POPUPj[쐬ƃzbgL[̓o^
		MakePopupMenu( &hMenuR, &hMenuL, &DevStruct, hWnd );

		// ^XNgCɃACR\̂H
		bShowTrayIcon = ((CREATESTRUCT*)lParam)->x;		// xWɓēn(^^;

		// ^XNo[ɃACR\
		if (bShowTrayIcon) {
			nIcon.cbSize = sizeof(NOTIFYICONDATA);
			nIcon.uID = 1;
			nIcon.hWnd = hWnd;
			nIcon.uFlags = NIF_MESSAGE|NIF_ICON|NIF_TIP;
			nIcon.hIcon = LoadImage( g_hInst, MAKEINTRESOURCE(IDI_REMI), IMAGE_ICON, 16, 16, 0 );
			// LoadIconƃftHg32x32[hĂ܂̂, LoadImageg
			nIcon.uCallbackMessage = WMMY_NOTIFYICON;
			lstrcpy( nIcon.szTip, szAppName );
			Shell_NotifyIcon( NIM_ADD, &nIcon );	// ^XNgCɃACRǉ
			if (nIcon.hIcon) DestroyIcon(nIcon.hIcon);
		}
		
		return 0;	// I

	case WM_DESTROY:
		DestroyPopupMenu(hMenuR, hMenuL, &DevStruct, hWnd );	// popuphotkey폜
		delete[] DevInfo;		// foCX̂߂̔zj
		if (bShowTrayIcon) Shell_NotifyIcon( NIM_DELETE, &nIcon );	// ^XNgCACR폜
		PlaySound( NULL, 0, SND_FILENAME|SND_NODEFAULT|SND_SYNC );	// TEh̍Đ~߂
		PostQuitMessage(0);
		return 0;

	case WM_QUERYENDSESSION:	// WindowsZbVI̊mF
		if ((UINT)wParam != 0) return TRUE;
		bEndClose = FALSE;
		// ăXL
		DestroyPopupMenu(hMenuR, hMenuL, &DevStruct, hWnd );	// popuphotkey폜
		DevInfo = ScanAllDevices( &DevStruct );
		MakePopupMenu( &hMenuR, &hMenuL, &DevStruct, hWnd );
		// IEject/Close
		for ( i=0; i<DevStruct.iRemDevs; i++ ) {
			// uIEjectvw肳ĂhCũfBAro
			if ( DevInfo[i].wSetting & INFOF_ENDEJECT ) {
				if ( EjectUnit( &DevInfo[i], 2 ) ) {
					if ( DevInfo[i].wSetting & INFOF_ENDCLOSE ) {
						bEndClose |= TRUE;
						DevInfo[i].wSetting |= INFOF_ENDOPENED;	// hAopenꂽflag
					}
				}
			}
		}
		WaitAllThread(20*1000);
		if (bEndClose) {
			// w肳ꂽԂ҂I
			Sleep(g_uEndCloseTime*100);
			//DWORD dwTime = GetTickCount();
			//while( GetTickCount() - dwTime < g_uEndCloseTime*100 ) ;
			// u10bClosevw肳ĂāAOpenꂽhCũg[
			for ( i=0; i<DevStruct.iRemDevs; i++ )
				if ( DevInfo[i].wSetting & INFOF_ENDOPENED ) EjectUnit( &DevInfo[i], 4 );
			WaitAllThread(20*1000);
		}
		return TRUE;

	case WM_DEVICECHANGE:
		if (wParam==DBT_DEVNODES_CHANGED) {		// foCXm[hύXꂽ
			DestroyPopupMenu(hMenuR, hMenuL, &DevStruct, hWnd );	// popuphotkey폜
			DevInfo = ScanAllDevices( &DevStruct );
			MakePopupMenu( &hMenuR, &hMenuL, &DevStruct, hWnd );
		}
		break;

	case WMMY_NOTIFYICON:		// ^XNgCŉNI
		hMenu = NULL;
		switch (lParam) {
		case WM_LBUTTONUP:	hMenu = hMenuL; break;
		case WM_RBUTTONUP:	hMenu = hMenuR;	break;
		default:			return 0;
		}
		if (hMenu) {
			GetCursorPos(&point);
			SetForegroundWindow(hWnd);
			TrackPopupMenu( hMenu, TPM_RIGHTBUTTON, point.x, point.y, 0, hWnd, NULL );
			PostMessage(hWnd,0,0,0); // POPUPmɕ\邽߂̂܂Ȃ
		}
		return 0;

	case WM_HOTKEY:
	case WM_COMMAND:
		i = LOWORD(wParam);	// i = Rg[̎ʔԍ
		if ( i>=0x200 && i<0x500 ) {	// 2xx:Eject, 3xx:Open, 4xx:Close
			// fBAEject/Open/Close
			BOOL bResult = EjectUnit( &DevInfo[LOBYTE(i)], HIBYTE(i) );
			// ȊỎEBhEOɎĂiWM_COMMAND̎̂݁j
			if (uMsg==WM_COMMAND) {
				HWND hToTopWnd = hWnd;
				do { hToTopWnd = GetNextWindow( hToTopWnd, GW_HWNDNEXT ); }
				while( !IsWindowVisible( hToTopWnd ) );
				BringWindowToTop( hToTopWnd );
			}
			// Eject/Open/CloseI
			return bResult;
		}
		switch(i) {
		case IDM_SETUP:
			DestroyPopupMenu(hMenuR, hMenuL, &DevStruct, hWnd );	// popuphotkey폜
			DevInfo = ScanAllDevices( &DevStruct );		// ăXL
			do {	// _CAO{bNX̕\
				DialogBoxParam( g_hResInst, MAKEINTRESOURCE(IDD_SETUP), hWnd,
					(DLGPROC)SetupDialogProc, (LPARAM)&DevStruct );
			} while (!MakePopupMenu( &hMenuR, &hMenuL, &DevStruct, hWnd ));	//PopupHotkeyĐ
			return 0;
		case IDM_EXIT:
			PostMessage( hWnd, WM_CLOSE, 0, 0 );
			return 0;
#ifdef ExitEjectTest
		case IDM_TEST:
			PostMessage( hWnd, WM_QUERYENDSESSION, 0, 0 );
			return 0;
#endif //ExitEjectTest
		}
		break;

	}
	return ( DefWindowProc(hWnd, uMsg, wParam, lParam) );
}


///////////////////////////////////////////
// ݒ_CAO

BOOL CALLBACK SetupDialogProc( HWND hDlgWnd, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
static DeviceStruct* lpDevStruct;
static DeviceInfo *DevInfo, *DevInfoTemp;
static int idPreEdit, iNowSelect;
int i;
TCHAR szDevDesc[32];
HWND hCtl;
HWND hParentWnd;
unsigned char InqBuf[MAX_LEN];
WORD wNotifyMsg;
char szIniName[MAX_PATH];

	switch (uMsg) {

	case WM_INITDIALOG:
		// foCX󂯎
		lpDevStruct = (DeviceStruct*)lParam;
		DevInfo = lpDevStruct->RemovablesInfo;

		// foCX𕡐obt@pӂ
		DevInfoTemp = new DeviceInfo[lpDevStruct->iRemDevs + 1];
		if (!DevInfoTemp) {		// mۂłȂ
			EndDialog( hDlgWnd, 0 );
			return TRUE;
		}

		// foCXXg쐬
		hCtl = GetDlgItem( hDlgWnd, IDC_LIST_DEVICE );
		hParentWnd = GetParent( hDlgWnd );
		for ( i=0; i<lpDevStruct->iRemDevs; i++ ) {
			// foCXRs[
			CopyMemory(&DevInfoTemp[i], &DevInfo[i], sizeof(DeviceInfo));
			// \p̃foCX쐬
			int adapter = DevInfoTemp[i].nHA;
			int target  = DevInfoTemp[i].nID;
			int lun     = DevInfoTemp[i].nLUN;
			szDevDesc[0] = '\0';
			if ( HA_Inquiry(adapter) )
				if ( Inquiry(adapter, target, lun, InqBuf) )
					MakeDeviceDescription( adapter, target, lun, InqBuf, szDevDesc );
			// foCXXgɒǉ
			SendMessage( hCtl, CB_ADDSTRING, 0, (LPARAM)szDevDesc );
		}
		// o[Wԍ\
		SendDlgItemMessage( hDlgWnd, IDC_STATIC_VERSION, WM_SETTEXT, 0, (LPARAM)szVersion );

		// EDIT BOX ̏
		SendDlgItemMessage( hDlgWnd, IDC_EDIT_CLOSE, WM_SETTEXT, 0, (LPARAM)g_lpszCloseWave );
		SendDlgItemMessage( hDlgWnd, IDC_EDIT_OPEN , WM_SETTEXT, 0, (LPARAM)g_lpszOpenWave  );
		SendDlgItemMessage( hDlgWnd, IDC_EDIT_EJECT, WM_SETTEXT, 0, (LPARAM)g_lpszEjectWave );

		// ICLOSE܂ł̑҂Ԃ̕\̏
		SendDlgItemMessage( hDlgWnd, IDC_SPIN_CLOSETIME, UDM_SETRANGE, 0, 100 );
		SendDlgItemMessage( hDlgWnd, IDC_SPIN_CLOSETIME, UDM_SETPOS, 0, g_uEndCloseTime );
		DispCloseTime( hDlgWnd, g_uEndCloseTime );

		// foCXXg̍ŏ̍ڂI
		iNowSelect = 0;
		SendDlgItemMessage( hDlgWnd, IDC_LIST_DEVICE, CB_SETCURSEL, 0, 0 );
		UpdateDialogItems( hDlgWnd, DevInfoTemp, 0 );
		idPreEdit = 0;
		return TRUE;

	case WM_COMMAND:
		wNotifyMsg = HIWORD(wParam);
		switch(LOWORD(wParam)) {

		case IDC_LIST_DEVICE:
			if ( wNotifyMsg == CBN_SELCHANGE ) {
				iNowSelect = SendMessage( (HWND)lParam, CB_GETCURSEL, 0, 0 );
				UpdateDialogItems( hDlgWnd, DevInfoTemp, iNowSelect );
			}
			break;

		case IDC_CHECK_TRAY:
			if ( wNotifyMsg == BN_CLICKED ) {
				DevInfoTemp[iNowSelect].wSetting ^= INFOF_TRAY;
				DevInfoTemp[iNowSelect].wSetting &= (-1^INFOF_ENDCLOSE);
				UpdateDialogItems( hDlgWnd, DevInfoTemp, iNowSelect );
			}
			break;

		case IDC_CHECK_DISABLE:
			if ( wNotifyMsg == BN_CLICKED ) {
				DevInfoTemp[iNowSelect].wSetting ^= INFOF_DISABLE;
				UpdateDialogItems( hDlgWnd, DevInfoTemp, iNowSelect );
			}
			break;

		case IDC_CHECK_ENDEJECT:
			if ( wNotifyMsg == BN_CLICKED ) {
				DevInfoTemp[iNowSelect].wSetting ^= INFOF_ENDEJECT;
				DevInfoTemp[iNowSelect].wSetting &= (-1^INFOF_ENDCLOSE);
				UpdateDialogItems( hDlgWnd, DevInfoTemp, iNowSelect );
			}
			break;

		case IDC_CHECK_SOUNDSYNC:
			if ( wNotifyMsg == BN_CLICKED )	DevInfoTemp[iNowSelect].wSetting ^= INFOF_SOUNDSYNC;
			break;

		case IDC_CHECK_ENDCLOSE:
			if ( wNotifyMsg == BN_CLICKED )	DevInfoTemp[iNowSelect].wSetting ^= INFOF_ENDCLOSE;
			break;

		case IDC_CHECK_NOTCHECKMEDIA:
			if ( wNotifyMsg == BN_CLICKED )	DevInfoTemp[iNowSelect].wSetting ^= INFOF_NOCHECK;
			break;

		case IDC_HOTKEY_OPENEJECT:
			if ( wNotifyMsg == EN_CHANGE ) {
				DevInfoTemp[iNowSelect].wHotkeyOpenEject =
					(WORD)SendMessage( (HWND)lParam, HKM_GETHOTKEY, 0, 0 ) & 0x7ff;
			}
			break;

		case IDC_HOTKEY_CLOSE:
			if ( wNotifyMsg == EN_CHANGE ) {
				DevInfoTemp[iNowSelect].wHotkeyClose =
					(WORD)SendMessage( (HWND)lParam, HKM_GETHOTKEY, 0, 0 ) & 0x7ff;
			}
			break;

		case IDC_EDIT_NAME:
			if ( wNotifyMsg == EN_CHANGE )
				GetDlgItemText( hDlgWnd, IDC_EDIT_NAME, DevInfoTemp[iNowSelect].szName, NAME_LEN );
			break;

		case IDC_EDIT_NAMECLOSE:
			if ( wNotifyMsg == EN_CHANGE
				&& (DevInfoTemp[iNowSelect].wSetting&(INFOF_TRAY|INFOF_DISABLE)) == INFOF_TRAY )
				GetDlgItemText( hDlgWnd, IDC_EDIT_NAMECLOSE, DevInfoTemp[iNowSelect].szNameClose, NAME_LEN );
			break;

		case IDC_EDIT_EJECT:
		case IDC_EDIT_OPEN:
		case IDC_EDIT_CLOSE:
			idPreEdit = LOWORD(wParam);
			break;

		case IDC_BUTTON_TEST:
			if ( wNotifyMsg == BN_CLICKED ) {
				TCHAR szFile[MAX_PATH];
				GetDlgItemText( hDlgWnd, idPreEdit, szFile, sizeof(szFile) );
				PlaySound( szFile, 0, SND_FILENAME|SND_ASYNC|SND_NODEFAULT );
			}
			break;

		case IDC_BUTTON_REF:
			if ( wNotifyMsg == BN_CLICKED ) {
				TCHAR szTitle[32];
				TCHAR szFile[MAX_PATH];
				TCHAR szInitialDir[MAX_PATH];
				LPSTR lpszFile;
				OPENFILENAME ofn;
				ZeroMemory( &ofn, sizeof(ofn) );
				LoadString( g_hResInst, IDS_COMDLGTITLE, szTitle, sizeof(szTitle) );
				GetDlgItemText( hDlgWnd, idPreEdit, szFile, sizeof(szFile) );
				if (GetFullPathName( szFile, sizeof(szInitialDir), szInitialDir, &lpszFile )) {
					if (lpszFile!=NULL) {
						lstrcpy( szFile, lpszFile );
						*lpszFile = '\0';
					} else szFile[0] = '\0';
				}
				ofn.lStructSize       = sizeof(OPENFILENAME);
				ofn.hwndOwner         = hDlgWnd;
				ofn.hInstance         = g_hResInst;
				ofn.lpstrFilter       = "RIFF WAVE (*.wav)\0*.wav\0";
				ofn.lpstrFile         = szFile;
				ofn.nMaxFile          = sizeof(szFile);
				ofn.lpstrInitialDir   = szInitialDir;
				ofn.lpstrTitle        = szTitle;
				ofn.lpfnHook 		  = (LPOFNHOOKPROC)CommonDialogProc;
				ofn.lpTemplateName    = MAKEINTRESOURCE(IDD_WAVESELECTFORM);	// TEheXg{^t
				ofn.Flags             = OFN_HIDEREADONLY | OFN_FILEMUSTEXIST | OFN_EXPLORER | OFN_ENABLETEMPLATE | OFN_ENABLEHOOK;
				if ( GetOpenFileName(&ofn) ) SendMessage( GetDlgItem(hDlgWnd,idPreEdit), WM_SETTEXT, 0, (LPARAM)szFile );
			}
			break;

		case IDOK:
			// iniɕۑ
			GetIniName(szIniName);
			g_uEndCloseTime = LOWORD(SendDlgItemMessage( hDlgWnd, IDC_SPIN_CLOSETIME, UDM_GETPOS, 0, 0 ));
			GetDlgItemText( hDlgWnd, IDC_EDIT_EJECT, g_lpszEjectWave, MAX_PATH );
			GetDlgItemText( hDlgWnd, IDC_EDIT_OPEN,  g_lpszOpenWave,  MAX_PATH );
			GetDlgItemText( hDlgWnd, IDC_EDIT_CLOSE, g_lpszCloseWave, MAX_PATH );
			WriteOtherSetting(szIniName);
			hCtl = GetDlgItem( hDlgWnd, IDC_LIST_DEVICE );
			for( i=0; i<lpDevStruct->iRemDevs; i++ ) {
				SendMessage( hCtl, CB_GETLBTEXT, i, (LPARAM)szDevDesc );
				// ݒ肵eۑ
				WriteDeviceSetting( szIniName, szDevDesc, &DevInfoTemp[i] );
				// ݒ肵eLɂ
				GetDeviceSetting( szIniName, szDevDesc, &lpDevStruct->RemovablesInfo[i] );
			}
			delete[] DevInfoTemp;
			EndDialog( hDlgWnd, 1 );
			break;

		case IDC_STATIC_VERSION:
			MessageBox( hDlgWnd, szVersionMB, szAppName, MB_ICONINFORMATION ); // version
			break;

		case IDC_STATIC_ICON:
			delete[] DevInfoTemp;
			EndDialog( hDlgWnd, 0 );	// _CAÕLZ
			PostMessage( GetParent(hDlgWnd), WMMY_NOTIFYICON, 0, WM_RBUTTONUP ); //popup\
			break;

		case IDCANCEL:
			delete[] DevInfoTemp;
			EndDialog( hDlgWnd, 0 );
			break;

		}
		return 0;

	case WM_VSCROLL:
		if ( LOWORD(wParam)==SB_THUMBPOSITION
			&& (HWND)lParam==GetDlgItem(hDlgWnd,IDC_SPIN_CLOSETIME) )
			DispCloseTime( hDlgWnd, HIWORD(wParam) );
		return 0;

	}

	return FALSE;
}

// ݒ_CAÕfoCX̐ݒ\
void UpdateDialogItems( HWND hDlgWnd, DeviceInfo *DevInfo, int i )
{
	BOOL bEnable = (((DevInfo[i].wSetting)&INFOF_DISABLE)==0);
	BOOL bClose  = (((DevInfo[i].wSetting)&(INFOF_DISABLE|INFOF_TRAY))==INFOF_TRAY);

	// eACẽOC
	EnableWindow( GetDlgItem(hDlgWnd,IDC_CHECK_TRAY),          bEnable );
	EnableWindow( GetDlgItem(hDlgWnd,IDC_CHECK_NOTCHECKMEDIA), bEnable );
	EnableWindow( GetDlgItem(hDlgWnd,IDC_CHECK_ENDEJECT),      bEnable );
	EnableWindow( GetDlgItem(hDlgWnd,IDC_CHECK_SOUNDSYNC),     bEnable );
	EnableWindow( GetDlgItem(hDlgWnd,IDC_HOTKEY_OPENEJECT),    bEnable );
	EnableWindow( GetDlgItem(hDlgWnd,IDC_EDIT_NAME),           bEnable );
	EnableWindow( GetDlgItem(hDlgWnd,IDC_STATIC_MENUSTR),      bEnable );
	EnableWindow( GetDlgItem(hDlgWnd,IDC_STATIC_OPENEJECT),    bEnable );
	EnableWindow( GetDlgItem(hDlgWnd,IDC_HOTKEY_CLOSE),        bClose  );
	EnableWindow( GetDlgItem(hDlgWnd,IDC_STATIC_CLOSE),        bClose  );
	EnableWindow( GetDlgItem(hDlgWnd,IDC_EDIT_NAMECLOSE),      bClose  );
	EnableWindow( GetDlgItem(hDlgWnd,IDC_CHECK_ENDCLOSE),
		((DevInfo[i].wSetting)&(INFOF_TRAY|INFOF_DISABLE|INFOF_ENDEJECT))==(INFOF_TRAY|INFOF_ENDEJECT) );

	// eACe̕\e
	SendDlgItemMessage( hDlgWnd, IDC_CHECK_TRAY,          BM_SETCHECK, (DevInfo[i].wSetting)&INFOF_TRAY,      0 );
	SendDlgItemMessage( hDlgWnd, IDC_CHECK_DISABLE,       BM_SETCHECK, (DevInfo[i].wSetting)&INFOF_DISABLE,   0 );
	SendDlgItemMessage( hDlgWnd, IDC_CHECK_ENDEJECT,      BM_SETCHECK, (DevInfo[i].wSetting)&INFOF_ENDEJECT,  0 );
	SendDlgItemMessage( hDlgWnd, IDC_CHECK_SOUNDSYNC,     BM_SETCHECK, (DevInfo[i].wSetting)&INFOF_SOUNDSYNC, 0 );
	SendDlgItemMessage( hDlgWnd, IDC_CHECK_ENDCLOSE,      BM_SETCHECK, (DevInfo[i].wSetting)&INFOF_ENDCLOSE,  0 );
	SendDlgItemMessage( hDlgWnd, IDC_CHECK_NOTCHECKMEDIA, BM_SETCHECK, (DevInfo[i].wSetting)&INFOF_NOCHECK,   0 );
	SendDlgItemMessage( hDlgWnd, IDC_HOTKEY_OPENEJECT, HKM_SETHOTKEY, DevInfo[i].wHotkeyOpenEject,      0 );
	SendDlgItemMessage( hDlgWnd, IDC_HOTKEY_CLOSE,     HKM_SETHOTKEY, bClose?DevInfo[i].wHotkeyClose:0, 0 );
	SendDlgItemMessage( hDlgWnd, IDC_EDIT_NAME,      WM_SETTEXT, 0, (LPARAM)DevInfo[i].szName      );
	SendDlgItemMessage( hDlgWnd, IDC_EDIT_NAMECLOSE, WM_SETTEXT, 0, bClose?(LPARAM)DevInfo[i].szNameClose:0 );

	char buf[64];
	LoadString(
		g_hResInst,
		((DevInfo[i].wSetting)&INFOF_TRAY)?IDS_SHORTCUT_OPEN:IDS_SHORTCUT_EJECT,
		buf,
		sizeof(buf)
		);
	SendDlgItemMessage( hDlgWnd, IDC_STATIC_OPENEJECT, WM_SETTEXT, 0, (LPARAM)buf );
}

// ICLOSE܂ł̑҂Ԃ\
void DispCloseTime( HWND hDlgWnd, int nTime )
{
	char szBuf[8];
	int nSec = nTime/10;
	wsprintf(szBuf, "%2d.%01d", nTime/10, nTime-nSec*10);
	SetWindowText( GetDlgItem(hDlgWnd,IDC_STATIC_CLOSETIME), szBuf );
}


// TEht@CI_CAOŃeXg{^̏s[`
BOOL CALLBACK CommonDialogProc( HWND hDlgWnd, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
	switch( uMsg ) {
	case WM_COMMAND:
		switch( LOWORD(wParam) ) {
		case IDB_WAVETEST:
			TCHAR szFile[MAX_PATH];
			if ( CommDlg_OpenSave_GetSpec( GetParent(hDlgWnd),
				szFile, sizeof(szFile)) <= sizeof(szFile)) {
				PlaySound( szFile, 0, SND_FILENAME|SND_ASYNC|SND_NODEFAULT );
			}
			return TRUE;
		}
	}
	return FALSE;
}

///////////////////////////////////////////
// INI ֘A

// init@C𓾂
BOOL GetIniName(LPSTR lpszIniName)
{
int len,i;
TCHAR szNameBuf[MAX_PATH];
DWORD dwNameLen = sizeof(szNameBuf);

	if ( !GetUserName( szNameBuf, &dwNameLen ) ) return GetStdIniName(lpszIniName);
	// User̎擾Ɏsꍇ"REMI.INI"Ԃ

	len = GetModuleFileName( g_hInst, lpszIniName, MAX_PATH );
	for( i=len-1; ; i-- ) {
		if (lpszIniName[i]=='\\') {
			lstrcpy( &(lpszIniName[i+1]), szNameBuf );
			lstrcpy( &(lpszIniName[i+dwNameLen]), ".ini" );
			break;
		} else if( i==0 ) {
			return FALSE;
		}
	}
	return TRUE;
}

// "st@C.INI"𓾂
BOOL GetStdIniName(LPSTR lpszIniName)
{
	int len = GetModuleFileName( g_hInst, lpszIniName, MAX_PATH );
	for (int i=len-1; ; i--) {
		if (lpszIniName[i]=='.') {
			lstrcpy( &(lpszIniName[i+1]), "INI" );
			break;
		} else if( i==0 ) {
			return FALSE;
		}
	}
	return TRUE;
}

// eݒ̓ǂݏoEۑ

void GetOtherSetting( LPSTR lpszIniName )
{
	GetPrivateProfileString( "Sound", "Eject", NULL, g_lpszEjectWave, MAX_PATH, lpszIniName );
	GetPrivateProfileString( "Sound", "Open",  NULL, g_lpszOpenWave, MAX_PATH, lpszIniName );
	GetPrivateProfileString( "Sound", "Close", NULL, g_lpszCloseWave, MAX_PATH, lpszIniName );
	g_uEndCloseTime  =  GetPrivateProfileInt( "General", "EndCloseTime", g_uEndCloseTime, lpszIniName );
}

void WriteOtherSetting( LPSTR lpszIniName )
{
char szBuf[32];

	WritePrivateProfileString( "Sound", NULL, NULL, lpszIniName );	// ZNV
	if (*g_lpszEjectWave != 0)
		WritePrivateProfileString( "Sound", "Eject", g_lpszEjectWave, lpszIniName );
	if (*g_lpszOpenWave != 0)
		WritePrivateProfileString( "Sound", "Open",  g_lpszOpenWave, lpszIniName );
	if (*g_lpszCloseWave != 0)
		WritePrivateProfileString( "Sound", "Close", g_lpszCloseWave, lpszIniName );
	WritePrivateProfileString( "General", NULL, NULL, lpszIniName );	// ZNV
	wsprintf( szBuf, "%d", g_uEndCloseTime );
	WritePrivateProfileString( "General", "EndCloseTime", szBuf, lpszIniName );
}

void GetDeviceSetting( LPSTR lpszIni, LPSTR lpszSection, DeviceInfo* lpInfo )
{
	lpInfo->wSetting  =  GetPrivateProfileInt( lpszSection, "Setting", lpInfo->wSetting, lpszIni );
	lpInfo->wHotkeyOpenEject = GetPrivateProfileInt( lpszSection, "HotkeyEject", lpInfo->wHotkeyOpenEject, lpszIni )|GetPrivateProfileInt( lpszSection, "HotkeyOpen",  lpInfo->wHotkeyOpenEject,  lpszIni );
	lpInfo->wHotkeyOpenEject = GetPrivateProfileInt( lpszSection, "HotkeyOpenEject", lpInfo->wHotkeyOpenEject, lpszIni );
	lpInfo->wHotkeyClose = GetPrivateProfileInt( lpszSection, "HotkeyClose", lpInfo->wHotkeyClose, lpszIni );
	GetPrivateProfileString( lpszSection, "Name", lpInfo->szName, lpInfo->szName, NAME_LEN-6, lpszIni );
	char buf[NAME_LEN];
	wsprintf(buf, "%s close", lpInfo->szName);
	GetPrivateProfileString( lpszSection, "NameClose", buf, lpInfo->szNameClose, NAME_LEN, lpszIni );
}

void WriteDeviceSetting( LPSTR lpszIni, LPSTR lpszSection, DeviceInfo* lpInfo )
{
char szBuf[32];

	WritePrivateProfileString( lpszSection, NULL, NULL, lpszIni );	//ZNV
	wsprintf( szBuf, "%d", lpInfo->wSetting );
	WritePrivateProfileString( lpszSection, "Setting", szBuf, lpszIni );
	wsprintf( szBuf, "%d", lpInfo->wHotkeyOpenEject );
	WritePrivateProfileString( lpszSection, "HotkeyOpenEject",  szBuf, lpszIni );
	WritePrivateProfileString( lpszSection, "Name", lpInfo->szName, lpszIni );
	if (lpInfo->wSetting&INFOF_TRAY) {
		wsprintf( szBuf, "%d", lpInfo->wHotkeyClose );
		WritePrivateProfileString( lpszSection, "HotkeyClose", szBuf, lpszIni );
		WritePrivateProfileString( lpszSection, "NameClose", lpInfo->szNameClose, lpszIni );
	}
}


///////////////////////////////////////////

// |bvAbvj[쐬ƃzbgL[̓o^
BOOL MakePopupMenu( HMENU* phMenuR, HMENU* phMenuL, DeviceStruct* pDevStruct, HWND hWnd )
{
	HMENU hMenuR, hMenuL;
	TCHAR szAddBuf[32];
	BOOL bSuccess = TRUE;

	DeviceInfo* DevInfo = pDevStruct->RemovablesInfo;

	hMenuR = CreatePopupMenu();
	hMenuL = CreatePopupMenu();

	for (int i = 0; i<pDevStruct->iRemDevs; i++) {
		if ( !(DevInfo[i].wSetting&INFOF_DISABLE) ) {
			if ( DevInfo[i].wSetting&INFOF_TRAY ) {
				if (DevInfo[i].szName[0]!=0) {
					AppendMenu( hMenuR, 0, 0x300+i, DevInfo[i].szName );
					AppendMenu( hMenuL, 0, 0x300+i, DevInfo[i].szName );
				}
				if ( DevInfo[i].wHotkeyOpenEject ) {
					bSuccess &= SetHotkey( hWnd, 0x300+i, DevInfo[i].wHotkeyOpenEject );
				}
				if (DevInfo[i].szNameClose[0]!=0) {
					AppendMenu( hMenuR, 0, 0x400+i, DevInfo[i].szNameClose );
					AppendMenu( hMenuL, 0, 0x400+i, DevInfo[i].szNameClose );
				}
				if ( DevInfo[i].wHotkeyClose ) {
					bSuccess &= SetHotkey( hWnd, 0x400+i, DevInfo[i].wHotkeyClose );
				}
			} else {
				if (DevInfo[i].szName[0]!=0) {
					AppendMenu( hMenuR, 0, 0x200+i, DevInfo[i].szName );
					AppendMenu( hMenuL, 0, 0x200+i, DevInfo[i].szName );
				}
				if ( DevInfo[i].wHotkeyOpenEject ) {
					bSuccess &= SetHotkey( hWnd, 0x200+i, DevInfo[i].wHotkeyOpenEject );
				}
			}
		}
	}
#ifdef ExitEjectTest
	AppendMenu( hMenuR, MF_SEPARATOR, 0, 0 );
	AppendMenu( hMenuR, 0, IDM_TEST, "Test" );
#endif //ExitEjectTest
	AppendMenu( hMenuR, MF_SEPARATOR, 0, 0 );
	LoadString( g_hResInst, IDS_SETUP, szAddBuf, 32 );
	AppendMenu( hMenuR, 0, IDM_SETUP, szAddBuf );
	LoadString( g_hResInst, IDS_EXIT, szAddBuf, 32 );
	AppendMenu( hMenuR, 0, IDM_EXIT, szAddBuf );

	*phMenuR = hMenuR;
	*phMenuL = hMenuL;

	return bSuccess;
}

// |bvAbvj[ƃzbgL[̍폜
void DestroyPopupMenu( HMENU hMenuR, HMENU hMenuL, DeviceStruct* pDevStruct, HWND hWnd )
{
	DeviceInfo* DevInfo = pDevStruct->RemovablesInfo;
	for (int i = 0; i<pDevStruct->iRemDevs; i++) {
		if ( !(DevInfo[i].wSetting&INFOF_DISABLE) ) {
			if ( DevInfo[i].wSetting&INFOF_TRAY ) {
				if ( DevInfo[i].wHotkeyOpenEject ) UnregisterHotKey( hWnd, 0x300+i );
				if ( DevInfo[i].wHotkeyClose ) UnregisterHotKey( hWnd, 0x400+i );
			} else {
				if ( DevInfo[i].wHotkeyOpenEject ) UnregisterHotKey( hWnd, 0x200+i );
			}
		}
	}
	DestroyMenu(hMenuR);
	DestroyMenu(hMenuL);
}

// zbgL[̓o^
// o^Ɏs烁bZ[W{bNX\
BOOL SetHotkey(HWND hWnd, int nID, WORD wHotkey )
{
	if ( !RegisterHotKey(hWnd, nID, HKF2MOD(wHotkey), LOBYTE(wHotkey)) ) {
		char buf[128];
		LoadString(g_hResInst, IDS_ERRHOTKEY, buf, sizeof(buf));
		MessageBox(hWnd, buf, szAppName, MB_ICONEXCLAMATION);
		return FALSE;
	}
	return TRUE;
}


///////////////////////////////////////////
// ASPI ֘A

// SẴfoCX𒲍RemovableDevicȅ擾
// [`ŃmۂĂ̂ŁAĂяo[`͂JKv
DeviceInfo* ScanAllDevices( DeviceStruct* lpDevStruct )
{
int i = 0;
int adapter, target, lun, iHostAdapterID, iMaxID;
HANDLE hTemp;
BYTE DevID;
unsigned char InqBuf[MAX_LEN];
DWORD dwDevices[128];
TCHAR szIniName[MAX_PATH], szBuf[NAME_LEN], szDeviceDesc[32];
DeviceInfo* DevInfo;

	//"[U[.ini"𓾂
	GetIniName( szIniName );
	//INI݂Ȃꍇ"REMI.ini"𓾂
	if ( (hTemp = CreateFile(szIniName,0,0,NULL,OPEN_EXISTING,0,NULL)) == INVALID_HANDLE_VALUE )
		GetStdIniName( szIniName );
	else CloseHandle( hTemp );
	
	// SẴfoCX𒲍ă[ouT
	for (adapter=0; adapter<(lpDevStruct->iHostAdapters); adapter++) {
		iHostAdapterID = HA_Inquiry(adapter);
		iMaxID = iHostAdapterID>>8; iHostAdapterID &= 0xff;
		for (target=0; target<iMaxID; target++) {
			if (target == iHostAdapterID) continue;	// HostAdapterskip
			for (lun=0; lun<8; lun++) {
				if ( Inquiry(adapter, target, lun, InqBuf ) ) {
					switch ( InqBuf[0] & 0x1f ) { // fBAro\ƍlfoCX̂݌o
					case 0: case 1: case 4: case 5: case 7:
						if ( InqBuf[1] & 0x80 ) {	// is Removable ?
							if (lun==0) DevID = InqBuf[0]&0x1f;
							else if ( (InqBuf[0]&0x1f) != DevID ) continue;	//foCXIDłȂƕs(PD΍)
							dwDevices[i] = MAKELONG(MAKEWORD(target,adapter),lun);	// (low,high)
							i++;
						}
					}
				}
			}
			if ( i > 255 ) break;
		}
		if ( i > 255 ) break;
	}
	
	if (i==0) return 0;		// [ou
	
	lpDevStruct->iRemDevs = i;	// [oufoCX̐
	if (lpDevStruct->RemovablesInfo) delete[] lpDevStruct->RemovablesInfo;
	DevInfo = lpDevStruct->RemovablesInfo = new DeviceInfo[i+1];
	if ( !DevInfo ) return 0;	// mۂłȂ
	
	// [ouׂ̍𓾂
	for ( i=0; i<lpDevStruct->iRemDevs; i++ ) {
		DevInfo[i].nHA  = adapter = HIBYTE(LOWORD(dwDevices[i]));
		DevInfo[i].nID  = target  = LOBYTE(LOWORD(dwDevices[i]));
		DevInfo[i].nLUN = lun     = LOBYTE(HIWORD(dwDevices[i]));
		
		HA_Inquiry( adapter );
		Inquiry( adapter, target, lun, InqBuf );
		
		MakeDeviceDescription( adapter, target, lun, InqBuf, szDeviceDesc );
		DevID = InqBuf[0] & 0x1f;
		DevInfo[i].wSetting = (DevID==4||DevID==5)?(INFOF_ENDEJECT|INFOF_TRAY):INFOF_ENDEJECT;
		if ( lun != 0 ) DevInfo[i].wSetting &= (-1^INFOF_ENDEJECT);	// LUN0ȊOȂIEject͂Ȃ
		DevInfo[i].wHotkeyOpenEject = 0;
		DevInfo[i].wHotkeyClose = 0;
		switch(DevID) {
			case 1:  DevID = IDS_SEQUENTIAL;	break;
			case 4:  DevID = IDS_CDR;			break;
			case 5:  DevID = IDS_CDROM;
				if ( IsPD( adapter, target ) ) {
					DevID = IDS_PD;
					DevInfo[i].wSetting = INFOF_ENDEJECT|INFOF_TRAY;
				}
				break;
			case 7:  DevID = IDS_MO;
				if ( IsPD( adapter, target ) ) {
					DevID = IDS_PD;
					DevInfo[i].wSetting = INFOF_ENDEJECT|INFOF_TRAY;
				}
				break;
			default: DevID = IDS_REMOVABLE;
		}
		LoadString( g_hResInst, DevID, szBuf, NAME_LEN-5 );
		if (lun==0) wsprintf( DevInfo[i].szName, "#%1X%1X %s", adapter, target, szBuf );
		else wsprintf( DevInfo[i].szName, "#%1X%1X%1X %s", adapter, target, lun, szBuf );
		GetDeviceSetting( szIniName, szDeviceDesc, &DevInfo[i] );
	}
	return DevInfo;
}

// PDłTRUEԂ
BOOL IsPD( int nHA, int nID )
{
	unsigned char InqBuf[MAX_LEN];
	HA_Inquiry( nHA );
	Inquiry( nHA, nID, 0, InqBuf );
	BYTE DevID = InqBuf[0]&0x1f;	// DevId = LUN:0̃foCXID
	if ( Inquiry( nHA, nID, 1, InqBuf ) ) {
		if ( (DevID == 7) && ((InqBuf[0] & 0x1f) == 5) ) return TRUE;
		// LUN=0  7(MO), LUN=1  5(CDROM) Ԃ PD drive ł
		if ( (DevID == 5) && ((InqBuf[0] & 0x1f) == 7) ) return TRUE;
		// ̋tł
		if ( (DevID == 5) && ((InqBuf[0] & 0x1f) == 5) ) {
			// LUN=0,1̗Ƃ5(CDROM)ԂꍇA
			// LUN=2̏Ɏsꍇ݂̂ocłƔF
			if ( !Inquiry( nHA, nID, 2, InqBuf ) ) return TRUE;
			// "QA"CD-ROMhCuPDƔFĂ܂ɂȂ邪A
			// ȃhCu͌Ɩ̂ŁAԂ\Ȃ낤
		}
	}
	return FALSE;
}


// w肳ꂽfoCXEject/Open/Closes
// sTRUE, sȂFALSEԂ
BOOL EjectUnit( DeviceInfo* DevInfo, int flag )
{
unsigned char InqBuf[MAX_LEN];
	
	int adapter = DevInfo->nHA;
	int target  = DevInfo->nID;
	int lun     = DevInfo->nLUN;

	if ( !HA_Inquiry(adapter) ) return FALSE;
	if ( !Inquiry(adapter, target, lun, InqBuf) ) return FALSE;

	// flag = 2:Eject, 3:Open, 4:Close
	// Is Media In ?
	TestUnitReady(adapter,target,lun);
	if ( flag==2 ) {
		if ( (DevInfo->wSetting&INFOF_NOCHECK) == 0 ) {
			if ( !TestUnitReady(adapter,target,lun) ) {	// media }ĂȂ
				if ( lun==0 && IsPD(adapter,target) ) {
					lun = 1;	// PDȂLUN=1ׂ
					TestUnitReady(adapter,target,lun);
					if ( !TestUnitReady(adapter,target,lun) ) return FALSE;
				} else return FALSE;
			}
		}
	} else flag--;
	// flag = 2:Eject|Open, 3:Close

	// w肳ĂWAVE炷
	LPSTR lpszWave = g_lpszEjectWave;
	if (DevInfo->wSetting&INFOF_TRAY) {
		if (flag==3) lpszWave = g_lpszCloseWave;
		else lpszWave = g_lpszOpenWave;
	}
	PlaySound( lpszWave, NULL,
		SND_NOSTOP|SND_FILENAME|SND_NODEFAULT|((DevInfo->wSetting&INFOF_SOUNDSYNC)?SND_SYNC:SND_ASYNC) );
	
	// Send Eject Command
	StartStopUnit( adapter, target, lun, flag );
	if ( lun==0 && IsPD(adapter,target) ) {		// 1998/06/20 added from there
		lun = 1;	// PDȂLUN=1ɂ
		StartStopUnit( adapter, target, lun, flag );
	}	// 1998/06/20 added over there
	
	return TRUE;
}


// Inquirtyœf[^foCX𐶐
void MakeDeviceDescription( int adapter, int target, int lun, unsigned char* lpInqBuf, LPSTR lpszDescBuf )
{
	//*(unsigned long*)lpszDescBuf = 0x20303023 + (unsigned long)adapter<<8 + (unsigned long)target<<16;
	*lpszDescBuf     = '#';
	*(lpszDescBuf+1) = '0'+adapter;
	*(lpszDescBuf+2) = '0'+target;
	if (lun != 0) *((++lpszDescBuf)+2) = '0'+lun;
	*(lpszDescBuf+3) = ' ';
	for ( int i=8; i<32; i++ ) {
		if ( *(lpInqBuf+i)<0x20 || *(lpInqBuf+i)>0x7e ) *(lpszDescBuf+i-4) = 0x20;
		else *(lpszDescBuf+i-4) = *(lpInqBuf+i);
	}
	*(lpszDescBuf+i-4) = '\0';
	return;
}


////////////////////////////////////////////////////
// REMI.CPP   by KEY(yuu igarashi) (c)1997,1998
